CON

  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  Buf_size = 4096
  
OBJ

  sd[3] :"fsrw_shared"
  text  :"tv_text"

VAR
  byte Header[44]             
  long SampleRate
  long NumOfChannels
  long BitsPerSample
  long NumOfSamples
  long Filesize
  long Buf1[Buf_size]
  long counter

Dat
  EncBit byte  0[8]

PUB main | ch,ch2,ch3, r1,r2,r3,encbitindex,x,char,eoencdata

{--------Activating TV-------------}

  text.start(12)

{--------Mounting Card-------------}
  sd[0].mount(0)

{-----------Reading Source file's Header----------}

  text.str(string("File sil.wav Info", 13))
  ReadHeader(string("sil.wav"))

{----------Copying header to target file----------}

  WriteHeader(string("silc.wav"))

{-----------Reading target file's Header----------}

  text.str(string("File silc.wav info",13))
  ReadHeader(string("silc.wav"))

{---Open source file and data file for read and---}
{------------- target for append------------------}

  r1:=sd[0].popen(string("sil.wav"),"r")
  r2:=sd[1].popen(string("data.txt"),"r")
  r2:=sd[2].popen(string("silc.wav"),"a")

{--------Move to Sample data at source file-------}

  GotoSampleData(string("sil.wav"))

{-Read Buf_size bytes to buf1 from source file and
  modify them before writing them to the target --}
    

  encbitindex:=0
  x:=1
  eoencdata:=False
  repeat 
    ch:=sd[0].pread(@Buf1,buf_size)
    if ch<0
      text.str(string("End of file",13))
      quit
    else
      x:=1
      repeat while x<buf_size
        repeat
          char:=sd[1].pgetc
          if char<0
            eoencdata:=TRUE
            repeat EncBitIndex from 0 to 7
              Encbit[EncBitIndex]:=(char>>(7-EncBitIndex))&%00000001
            repeat Encbitindex from 0 to 7
              if byte[@encbit][encbitindex]==$01
                Byte[@Buf1][x]:=(Byte[@Buf1][x]&$fe)+$01
                x+=2
              else                   
                Byte[@Buf1][x]&=$fe
                x+=2
            quit
          else                                                                   
            repeat EncBitIndex from 0 to 7
              Encbit[EncBitIndex]:=(char>>(7-EncBitIndex))&%00000001
            repeat Encbitindex from 0 to 7
              if byte[@encbit][encbitindex]==$01
                Byte[@Buf1][x]:=(Byte[@Buf1][x]&$fe)+$01
                x+=2
              else                   
                Byte[@Buf1][x]&=$fe
                x+=2
        if eoencdata==TRUE
          quit
    sd[2].pwrite(@Buf1,ch)
  sd[0].pclose
  sd[1].pclose
  sd[2].pclose
  text.str(string("encoded",13))

Pri ReadHeader(fname)|r 
  r:=sd[0].popen(fname,"r")                   
  if (r<>0)
    repeat
  r:=sd[0].pread(@Header, 44)                              'Read the header
  SampleRate:=Header[27]<<24+Header[26]<<16+Header[25]<<8+Header[24]
  text.str(string("Sample rate      : "))
  text.dec(SampleRate)
  text.out(13)
  text.out(" ")
  NumOfChannels:=Header[23]<<8+Header[22]
  text.str(string("# of channels    : "))
  text.dec(NumOfChannels)
  text.out(13)
  text.out(" ")
  BitsPerSample:=Header[35]<<8+Header[34]
  text.str(string("Bits per sample  : "))
  text.dec(BitsPerSample)
  text.out(13)
  text.out(" ")
  Filesize:=Header[43]<<24+Header[42]<<16+Header[41]<<8+Header[40]+44
  text.str(string("File size (bytes): "))
  text.dec(FileSize)
  text.out(13)
  text.out(" ")
  NumOfSamples:=(8*(Filesize-44))/(NumOfChannels*BitsPerSample)
  text.str(string("# of Samples     : "))
  text.dec(NumOfSamples)
  text.out(13)
  sd[0].pclose
                                
Pri WriteHeader(fname)|sta,bytes,r
  r := sd[2].popen(fname, "w")
  sta := cnt
  bytes := 0
  sd[2].pwrite(@Header,44)
  sd[2].pclose

Pri GotoSampleData(fname)|r
  r:=sd[0].popen(fname,"r")
  repeat 44
    r:=sd[0].pgetc